unit mycbase;

interface

uses
  SysUtils{, QControls, QDialogs}, CodeBase, MessLog;

  function myStrToInt(s: string): integer;
  procedure replace(d4: data4; fld, data: string);
  function fetch(d4: data4; fld: string): string;
  function dfetch(d4: data4; fld: string): double;
  function ifetch(d4: data4; fld: string): integer;
  function lfetch(d4: data4; fld: string ): longint;
  function tfetch(d4: data4; fld: string): boolean;
  function dtfetch(d4: data4; fld: string): TDateTime;
  function mOpen(cb: code4; filename, tagname: string): data4;
  procedure CopyStru(cb: CODE4; fromName, toName: string);

implementation

uses
  sMain;

function SafeDir(TmpStr: string): string;
begin
  if(Length(TmpStr) > 0)then
    if(TmpStr[Length(TmpStr)] = '\')then
      Delete(TmpStr, Length(TmpStr), 1);
  Result := TmpStr;
end;

function myStrToInt(s: string): integer;
var
  Code, i: integer;
begin
  // use this to verify data entered is all numeric
  Val(s, i, Code);
  if(Code <> 0)then
    result := 0
  else
    result := i;
end;

// replace a string into fld
procedure replace(d4: data4; fld, data: string);
var
  f4: FIELD4;
begin
  f4 := d4field(d4, PChar(fld));

  if(f4 <> nil)then
    case f4Type(f4) of
      Integer('M'):
        f4memoassign(d4field(d4, PChar(fld)), PChar(data));
     else
       f4assign(d4field(d4, PChar(fld)), PChar(data));
    end;
end;

function fetch(d4: data4; fld: string): string;
var
  f4: FIELD4;
begin
  f4 := d4field(d4, PChar(fld));
  if(f4 <> nil)then
    Result := Trim(StrPas(f4memoStr(f4)))
  else
    Result := '';
end;

function dfetch(d4: data4; fld: string): double;
begin
  Result := f4double(d4field(d4, PChar(fld)));
end;

function ifetch(d4: data4; fld: string): integer;
begin
  Result := f4int(d4field(d4, PChar(fld)));
end;

function lfetch(d4: data4; fld: string ): longint;
begin
  Result := f4long(d4field(d4, PChar(fld)));
end;

function tfetch(d4: data4; fld: string): boolean;
begin
  result := (f4true(d4field(d4, PChar(fld))) <> 0);
end;

function dtfetch(d4: data4; fld: string): TDateTime;
var
  dt: string;
begin
  dt := fetch(d4, fld);

  // if can't do it then return today
 try
  Result := EncodeDate(myStrToInt(Copy(dt, 1, 4)), myStrToInt(Copy(dt, 5, 2)),
                                                       myStrToInt(Copy(dt, 7, 2)));
 except
  Result := Date;
 end;
end;

// re-wrote the mOpen, as we don't want any message boxes or the like...
function mOpen(cb: code4; filename, tagname: string): data4;
var
  d4: data4;
  FullFileName: string;
  i, ctr{, ErrCode}: integer;
begin
  d4 := nil;  // start off with it failing...
  if(Length(ExtractFilePath(filename)) = 0)then
    FullFileName := SafeDir(GetCurrentDir) + '\' + Trim(filename)
  else
    FullFileName := Trim(filename);

  if(Length(ExtractFileExt(FullFileName)) = 0)then
    FullFileName := ChangeFileExt(FullFileName, '.dbf');
//Sql2Dbf.Mess.Format('mopening %s', [FullFileName]);
  if(FileExists(FullFileName))then
  begin
    i := code4errOpen(cb, 0);       // keep silent when error...
    ctr := 0;
    while(True)do
    begin
//Sql2Dbf.Mess.Format('d4open(cb, %s)', [FullFileName]);

      d4 := d4open(cb, PChar(FullFileName));

      // why do we care WHAT the error is, just that there is one!
      // the return will be 0 (d4 = nil) if there is any problem...
      //      ErrCode := code4errorCode(cb, r4check);
      //      if((ErrCode < r4success) or (d4 = nil))then

      // Trap table open errors, cycle until table becomes free or
      // after approx. 2 secs give up...
      if(d4 = nil)then
      begin
//Sql2Dbf.Mess.Format('FAILED d4open(cb, %s)', [FullFileName]);
        Sleep(100);
        ctr := ctr + 1;
        if(ctr > 20)then    // approx 2 seconds...
          break;
      end
      else
      begin
//Sql2Dbf.Mess.Format('d4open(cb, %s)  OK!', [FullFileName]);
        break;
      end;
    end;

    code4errOpen(cb, i);        // return to original error mode...
  end
  else
    MessageLog.Format('File %s NOT FOUND!', [FullFileName]);

  if(d4 <> nil)then
    if(Length(tagname) > 0)then
      d4tagSelect(d4, d4tag(d4, PChar(tagname)));
  Result := d4;
//Sql2Dbf.Mess.Flush('exiting');
end;

(*
function mOpen(cb: code4; filename, tagname: string): data4;
var
  d4: data4;
  start, present: TTimeStamp;
  i, mr: integer;
  sJunk: string;
begin
  d4 := nil;
  // Trap table opening errors here and cycle message box until table becomes
  // free.  Pressing Ok on dialog box attempts again, Cancel will cause program
  // to crash.
  if(Length(ExtractFilePath(filename)) = 0)then
  begin
    GetDir(0, sJunk);
    sJunk := SafeDir(sJunk) + '\' + Trim(filename);
  end
  else
    sJunk := Trim(filename);
  if(Length(ExtractFileExt(filename)) = 0)then
    sJunk := ChangeFileExt(filename, '.dbf');

  if(not FileExists(sJunk))then
    MessageDlg('Error', 'Table called ' + sJunk + ' does not exists', mtError, [mbOk], 0)
  else
  begin
    start := DateTimeToTimeStamp(Now);
    mr := mrOk;
    i := code4errOpen(cb, 0);
    repeat
      d4 := d4open(cb, PChar(filename));
      if(code4errorCode(cb, R4CHECK) <> 0)then
      begin
        present := DateTimeToTimeStamp(Now);
        // wait 3 seconds before displaying the error message
        if(start.Time + 3000 < present.time)then
          mr := MessageDlg('Please Wait ...',
                           'Table called ' + sJunk + ' in exclusive use, please wait a few moments then press ''Ok''.',
                            mtError, [mbOk, mbCancel], 0, mbOk);
      end;
    until (code4errorCode(cb, R4CHECK) <> R4NOOPEN) or (mr = mrCancel);
    code4errOpen(cb, i);
  end;

  if(Length(tagname) > 0)then
    d4tagSelect(d4, d4tag(d4, PChar(tagname)));
  Result := d4;
end;
*)

procedure CopyStru(cb: CODE4; fromName, toName: string);
var
  d4from: DATA4 ;     // data4 handles
  index: INDEX4;
  fieldInfo: PFIELD4INFO;
  indexInfo: PTAG4INFO;
begin
  d4from := mOpen(cb, fromName, '');     // open the input file
  if(d4from <> nil)then
  begin
    fieldInfo := d4fieldInfo(d4from);     // get the field info from the file
    index := d4index(d4from, nil);        // get the master (.CDX) index
    if(index <> INDEX4(0))then
      indexInfo := i4tagInfo(index)       // get the index info, if there is one!
    else
      indexInfo := nil;

    d4create(cb, PChar(toName), fieldInfo, indexInfo);    // create the new file

    if(indexInfo <> nil)then
      u4free(PVoid(indexInfo));             // clean up

    u4free(PVoid(fieldInfo));               // and more clean up
    
    d4close(d4from);
  end;
end;

end.

